{1/2 Copyright by Leonid Youriev 1992, 93}
{$I VERSION}
{$P-}

unit Drivers;

interface

{$O-}

uses	Objects, Recode, Styles;

{$I VERSION}
{$P-}		{
			 祭 樥 FormatStr() ࠡ⠥ ४⭮,
			..    ࠬ  ப ।  Var
			}

const

	evMouseDown = $0001;
	evMouseUp   = $0002;
	evMouseMove = $0004;
	evMouseAuto = $0008;
	evKeyDown   = $0010;
	evCommand   = $0100;
	evBroadcast = $0200;

	evNothing   = $0000;
	evMouse		= $000F;
	evKeyboard  = $0010;
	evMessage   = $FF00;

	kbEsc		= $011B;	kbAltSpace	= $0200;	kbCtrlIns	= $9200;
	kbShiftIns	= $D200;	kbCtrlDel	= $9300;	kbShiftDel	= $D300;
	kbBack		= $0E08;	kbCtrlBack	= $0E7F;	kbShiftTab	= $0F00;
	kbTab		= $0F09;	kbAltQ		= $1000;	kbAltW		= $1100;
	kbAltE		= $1200;	kbAltR		= $1300;	kbAltT		= $1400;
	kbAltY		= $1500;	kbAltU		= $1600;	kbAltI		= $1700;
	kbAltO		= $1800;	kbAltP		= $1900;	kbCtrlEnter = $1C0A;
	kbEnter		= $1C0D;	kbAltA		= $1E00;	kbAltS		= $1F00;
	kbAltD		= $2000;	kbAltF		= $2100;	kbAltG		= $2200;
	kbAltH		= $2300;	kbAltJ		= $2400;	kbAltK		= $2500;
	kbAltL		= $2600;	kbAltZ		= $2C00;	kbAltX		= $2D00;
	kbAltC		= $2E00;	kbAltV		= $2F00;	kbAltB		= $3000;
	kbAltN		= $3100;	kbAltM		= $3200;	kbF1		= $3B00;
	kbF2		= $3C00;	kbF3		= $3D00;	kbF4		= $3E00;
	kbF5		= $3F00;	kbF6		= $4000;	kbF7		= $4100;
	kbF8		= $4200;	kbF9		= $4300;	kbF10		= $4400;
	kbHome		= $4700;	kbUp		= $4800;	kbPgUp		= $4900;
	kbGrayMinus	= $4A2D;	kbLeft		= $4B00;	kbRight		= $4D00;
	kbGrayPlus	= $4E2B;	kbEnd		= $4F00;	kbDown		= $5000;
	kbPgDn		= $5100;	kbIns		= $5200;	kbDel		= $5300;
	kbShiftF1	= $5400;	kbShiftF2	= $5500;	kbShiftF3	= $5600;
	kbShiftF4	= $5700;	kbShiftF5	= $5800;	kbShiftF6	= $5900;
	kbShiftF7	= $5A00;	kbShiftF8	= $5B00;	kbShiftF9	= $5C00;
	kbShiftF10	= $5D00;	kbCtrlF1	= $5E00;	kbCtrlF2	= $5F00;
	kbCtrlF3	= $6000;	kbCtrlF4	= $6100;	kbCtrlF5	= $6200;
	kbCtrlF6	= $6300;	kbCtrlF7	= $6400;	kbCtrlF8	= $6500;
	kbCtrlF9	= $6600;	kbCtrlF10	= $6700;	kbAltF1		= $6800;
	kbAltF2		= $6900;	kbAltF3		= $6A00;	kbAltF4		= $6B00;
	kbAltF5		= $6C00;	kbAltF6		= $6D00;	kbAltF7		= $6E00;
	kbAltF8		= $6F00;	kbAltF9		= $7000;	kbAltF10	= $7100;
	kbCtrlPrtSc	= $7200;	kbCtrlLeft	= $7300;	kbCtrlRight = $7400;
	kbCtrlEnd	= $7500;	kbCtrlPgDn	= $7600;	kbCtrlHome	= $7700;
	kbAlt1		= $7800;	kbAlt2		= $7900;	kbAlt3		= $7A00;
	kbAlt4		= $7B00;	kbAlt5		= $7C00;	kbAlt6		= $7D00;
	kbAlt7		= $7E00;	kbAlt8		= $7F00;	kbAlt9		= $8000;
	kbAlt0		= $8100;	kbAltMinus	= $8200;	kbAltEqual	= $8300;
	kbCtrlPgUp	= $8400;	kbNoKey		= $0000;	kbAltEnter	= $1C00;
	kbF11		= $8500;	kbShiftF11	= $8700;	kbAltF11	= $8B00;
	kbF12		= $8600;	kbShiftF12	= $8800;	kbAltF12	= $8C00;
	kbCtrlF11	= $8900;	kbCtrlF12	= $8A00;	kbAltBack	= $0E00;
	kbAltEsc	= $0100;	kbAltTab	= $A500;	kbCtrlTab	= $9400;
	kbAltIns	= $A200;	kbAltDel	= $A300;	kbCtrlPrn	= $7200;
	kbCtrlUp	= $8D00;	kbCtrlDown	= $9100;	kbCtrl_5	= $8F00;

	kbRightShift	= $0001;
	kbLeftShift		= $0002;
	kbCtrlShift		= $0004;
	kbAltShift		= $0008;
	kbScrollState	= $0010;
	kbNumState		= $0020;
	kbCapsState		= $0040;
	kbInsState		= $0080;

	mbLeftButton	= $01;
	mbRightButton	= $02;
	mbOtherButton	= $04;

type

	TMouseState = (msNormal, msMark, msWait, msDo, msPress, msNoInit);

	PEvent = ^TEvent;
	TEvent = record
		What : Word;
			case Word of
				evNothing	: ();
				evMouse		: (
					Buttons	: Byte;
					Double	: Boolean;
					Where	: TPoint);
				evKeyDown	: (
					case Integer of
						0	: (KeyCode	: Word);
						1	: (CharCode	: Char;
							   ScanCode	: Byte));
				evMessage	: (
					Command	: Word;
						case Word of
							0	: (InfoPtr	: Pointer);
							1	: (InfoLong	: Longint);
							2	: (InfoWord	: Word);
							3	: (InfoInt	: Integer);
							4	: (InfoByte	: Byte);
							5	: (InfoChar	: Char));
		end;

const

	ShiftStateCall	: Byte = 0;
	TimerHandler	: Pointer = NIL;

var

	PrnDelay		: array [0..3] of Byte;
	KeyBoardMap		: array [0..31] of Char;
	XlatKeyBoard	: array [0..127] of Char;

	DevicesInfo : record
		MonoScreen		: Boolean;
		StartupMode		: Word;
		ScreenMode		: Word;
		MasterAble		: Boolean;
		Vscan			: Word;
		ScreenWidth		: Byte;
		ScreenHeight	: Byte;
		HiResScreen		: Boolean;
		CheckSnow		: Boolean;
		ScreenBuffer	: Pointer;
		CursorLines		: Word;
		CurrentFont		: Byte;
		KeyBoardType	: Byte;
		ButtonCount		: Byte;
	end;

procedure InitDrivers;
procedure DoneDrivers;
procedure InitEvents;
procedure DoneEvents;
procedure GetMouseEvent (var Event : TEvent);
procedure GetKeyEvent (var Event : TEvent);
procedure NormalMouse;
procedure MarkMouse (The : TMouseState);
procedure SetVideoMode (Mode: Word);
procedure ClearScreen;
procedure SetCurFont (Num1, Num2 : byte);
{$IFDEF SupportMasterFont}
procedure SaveFont;
procedure RestoreFont;
procedure SetMaster (The : Boolean);
procedure ResetMaster;
procedure SetMasterCodeStyle (The : TCharCodeStyles);
{$ENDIF}
procedure SetBlink (As : Boolean);
procedure SetBorderColor (Color : Byte);
function NegTextColor (C, Mask : Byte) : Byte;
function NegBackColor (C, Mask : Byte) : Byte;
function MakeColor (C1, C2 : Byte) : Byte;
function SwapColor (C : Byte) : Byte;
inline (
	$58/		{	POP		AX		}
	$B1/$04/	{	MOV		CL, 4	}
	$D2/$C8		{	ROR		AL, CL	}
	);

procedure InitVideo;
procedure DoneVideo;
procedure DetectVideo;

function GetAltChar (KeyCode : Word) : Char;
function GetAltCode (Ch : Char) : Word;
function CtrlToArrow (KeyCode : Word) : Word;

procedure FormatStr (var Result : String; Format : String; var Params);
procedure PrintStr (S : String);

procedure MoveBuf (var Dest; var Source; Attr : Word; Count : Word);
procedure MoveCBuf (var Dest; var Source; Attr : Word; Count : Word);
procedure MoveChar (var Dest; C : Char; Attr : Word; Count : Word);
procedure MoveCStr (var Dest; Str : String; Attrs : Word);
procedure MoveStr (var Dest; Str : String; Attr : Word);
procedure MoveMarkCStr (var Dest; Str : String; Attr : Word; Size : Word; SCOff : TSpecialCharsUser);
function CStrLen (var S : String): Integer;
function KeyCase (C : Char) : Char;
function HotKey (S : String) : Char;

const

	smBW80			= $0002;
	smCO80			= $0003;
	smMono			= $0007;
	smFont8x8		= $0100;

{$IFDEF SupportMasterMouse}
	MouseImage			: array [0..8] of Char = '';

	MasterCharsIBMPC	= {''+}''+''+'';
	MasterCharsALT		= {''+}''+''+'';
	MasterCharsKOI8		= {''+}''+''+'';
	MasterCharsKOI8M	= {''+}''+''+'';
	MasterCharsMIC		= {''+}''+''+'';
	MasterCharsMAIN		= {''+}''+''+'';
{$ELSE}
	MasterCharsIBMPC	= {''+}{''+''+}'';
	MasterCharsALT		= {''+}{''+''+}'';
	MasterCharsKOI8		= {''+}{''+''+}'';
	MasterCharsKOI8M	= {''+}{''+''+}'';
	MasterCharsMIC		= {''+}{''+''+}'';
	MasterCharsMAIN		= {''+}{''+''+}'';
{$ENDIF}

{$IFDEF SupportMasterFont}
{$IFDEF SupportMasterMouse}
	ReplaceCharsInUse	= 17;
	MasterCharsInUse	= 15;
{$ELSE}
	ReplaceCharsInUse	= 8;
	MasterCharsInUse	= 6;
{$ENDIF}
	ReplaceCharMap		: array [0..ReplaceCharsInUse - 1] of Word = (
		$000, $001, $102, $008, $00A, $00B, $10C, $00D,
	{	$00E, $016, $017, $00C, $07F, $0FF,}
		$000, $000, $000, $000, $000, $000, $000, $000, $000);
	_RaI		= #0#1#2' ';
	_RaB		= #8;
	_ChI		= #10#11#12' ';
	_ChB		= #13;
{$ELSE}
	_RaI		= '( ) ';
	_RaB		= #7;
	_ChI		= '[ ] ';
	_ChB		= 'X';
{$ENDIF}
	PrnHandle			: Pointer = NIL;

var

	ButtonShadowChars	: array [0..6] of Char;
	MenuFrameChars		: array [0..19] of Char;
	XlatScreen			: array [0..511] of Char;

{$IFDEF SupportMasterFont}
type
	TMasterCharMap		= array [0..Length (MasterCharsIBMPC) - 1] of Char;

var
	MasterCharMap		: TMasterCharMap;
{$ENDIF}

implementation

uses	Sysvars, CharLog, Resident, App;

{$IFDEF SupportMasterFont}
const
	StandartImage		: array [0..7] of Char =
		'( )[ ]X';

var
	MasterFontSave		: array [0..ReplaceCharsInUse * 32 - 1] of Byte;
{$ENDIF}

function NegTextColor (C, Mask : Byte) : Byte; assembler;
asm
	MOV		AL, C
	AND		AL, 0F0H
	MOV		AH, AL
	MOV		CL, 4
	SHR		AH, CL
	XOR		AH, Mask
	AND		AH, 0FH
	OR		AL, AH
end;

function NegBackColor (C, Mask : Byte) : Byte; assembler;
asm
	MOV		AL, C
	AND		AL, 0FH
	MOV		AH, AL
	MOV		CL, 4
	SHL		AH, CL
	XOR		AH, Mask
	AND		AH, 0F0H
	OR		AL, AH
end;

function MakeColor (C1, C2 : Byte) : Byte; assembler;
asm
	MOV		CL, 4
	MOV		AL, C1
	MOV		AH, C2
	SAL		AH, CL
	AND		AX, 0F00FH
	OR		AL, AH
end;

procedure SetCurFont (Num1, Num2 : Byte); assembler;
asm
	MOV		AL, Num1
	MOV		AH, Num2
	AND		AX, 0303H
	SAL		AH, 1
	SAL		AH, 1
	OR		AH, AL
	MOV		DX, 3C4H
	MOV		DevicesInfo.CurrentFont, AH
	MOV		AL, 3
	OUT		DX, AX
end;

procedure VideoInt; near; assembler;
asm
	PUSH	BP
	PUSH	ES
	INT		10H
	POP		ES
	POP		BP
end;

procedure GetCrtMode; near; assembler;
asm
	MOV		AH, 0FH
	CALL	VideoInt
	MOV		DevicesInfo.ScreenWidth, AH
	MOV		CX, 0B800H
	CMP		AL, 7
	JNE		@1
	MOV		CH, 0B0H
@1:	PUSH	AX
	MOV		AX, 1130H
	MOV		BH, 0
	MOV		DL, 0
	MOV		CX, 8
	CALL	VideoInt
	MOV		DevicesInfo.Vscan, CX
	INC		DL
	MOV		DevicesInfo.ScreenHeight, DL
	DEC		DL
	POP		AX
	MOV		DH, AH
	CMP		DL, 25
	SBB		AH, AH
	INC		AH
end;

procedure SetCrtMode; near; assembler;
asm
	MOV		ES, Seg0040
	MOV		BL, 20H
	CMP		AL, smMono
	JNE		@1
	MOV		BL, 30H
@1:	AND		ES:Equipment.Byte, 0CFH
	OR		ES:Equipment.Byte, BL
	AND		ES:CrtInfo, 0FEH
	PUSH	AX
	MOV		AH, 0
	CALL	VideoInt
	POP		AX
	OR		AH, AH
	JE		@2
	MOV		AX, 1112H
	MOV		BL, 0
	CALL	VideoInt
	MOV		AX, 1130H
	MOV		BH, 0
	MOV		DL, 0
	CALL	VideoInt
	CMP		DL, 42
	JNE		@2
	OR		ES:CrtInfo,1
	MOV		AH,1
	MOV		CX, 600H
	CALL	VideoInt
	MOV		AH, 12H
	MOV		BL, 20H
	CALL	VideoInt
@2:
end;

procedure FixCrtMode; near; assembler;
asm
	CMP		AL, smMono
	JE		@1
	CMP		AL, smCO80
	JE		@1
	CMP		AL, smBW80
	JE		@1
	MOV		AX, smCO80
@1:
end;

procedure SetCrtData; near; assembler;
asm
	XOR		AX, AX
	CALL	GetCrtMode
	MOV		CL, 1
	OR		DL, DL
	JNE		@1
	MOV		CL, 0
	MOV		DL, 24
@1:	INC		DL
	MOV		DevicesInfo.ScreenMode, AX
	MOV		DevicesInfo.ScreenWidth, DH
	MOV		DevicesInfo.ScreenHeight, DL
	MOV		DevicesInfo.HiResScreen, CL
	XOR		CL, 1
	MOV		BX, 0B800H
	CMP		AL, smMono
	JNE		@2
	MOV		CL,0
	MOV		BH, 0B0H
@2:	MOV		DevicesInfo.CheckSnow, CL
	MOV		DevicesInfo.ScreenBuffer.Word [0], 0
	MOV		DevicesInfo.ScreenBuffer.Word [2], BX
	MOV		AH, 3
	MOV		BH, 0
	CALL	VideoInt
	MOV		DevicesInfo.CursorLines, CX
	MOV		AH, 1
	MOV		CX, 2000H
	CALL	VideoInt
@4:
end;

{$IFDEF SupportMasterFont}
{$L MS_FONT.OBJ}
procedure LoadFontPtr; near; external;

procedure SaveFont; assembler;
asm
	CALL	Open_A000_Font
	PUSH	DS
	POP		ES
	MOV		DI, OFFSET MasterFontSave
	MOV		CX, TYPE ReplaceCharMap / 2
	CLD
	MOV		SI, OFFSET ReplaceCharMap
@1:	LODSW
	MOV		AH, 0
	PUSH	SI
	PUSH	DS
	PUSH	CX
	MOV		CL, 5
	SHL		AX, CL
	MOV		SI, AX
	MOV		DS, SegA000
	MOV		CL, 16
	REP		MOVSW
	POP		CX
	POP		DS
	POP		SI
	LOOP	@1
	CALL	Close_A000_Font
	STI
end;

procedure RestoreFont; assembler;
asm
	CALL	Open_A000_Font
	MOV		DX, OFFSET MasterFontSave
	MOV		CX, TYPE ReplaceCharMap / 2
	CLD
	MOV		SI, OFFSET ReplaceCharMap
	MOV		ES, SegA000
@1: LODSW
	MOV		AH, 0
	XCHG	DX, SI
	PUSH	CX
	MOV		CL, 5
	SHL		AX, CL
	MOV		DI, AX
	MOV		CL, 16
	REP		MOVSW
	POP		CX
	XCHG	DX, SI
	LOOP	@1
	CALL	Close_A000_Font
	STI
end;

procedure SetMasterFont; near; assembler;
var
	Count	: Word;
asm
	MOV		Count, OFFSET MasterCharMap
	CALL	Open_A000_Font
	CLD
	MOV		BX, DevicesInfo.Vscan
	CALL	LoadFontPtr
	SUB		BX, CX
	MOV		DX, BX
	SAR		DX, 1
	SUB		BX, DX
	MOV		DH, CL
	MOV		CX, ReplaceCharsInUse
	MOV		DI, OFFSET ReplaceCharMap
	MOV		ES, SegA000
@1:	XCHG	SI, DI
	LODSW
	PUSH	SI
	PUSH	CX
	PUSH	DI
	PUSH	BX
	MOV		DI, AX
	AND		DI, 0FFH
	MOV		CL, 5
	SHL		DI, CL
	TEST	AH, AH
	JNE		@2
	MOV		SI, Count
	LODSB
	MOV		Count, SI
	MOV		AH, 0
	SHL		AX, CL
	MOV		SI, AX
	MOV		CL, BYTE PTR DevicesInfo.Vscan
	RCR		CX, 1
	PUSH	SI
	SEGES	REP		MOVSW
	POP		DI
@2:	POP		BX
	MOV		AL, 0
	MOV		CL, BL
	REP		STOSB
	MOV		CL, DH
	POP		SI
	SEGCS	REP		MOVSB
	MOV		CL, DL
	REP		STOSB
	POP		CX
	POP		DI
	LOOP	@1
	CALL	Close_A000_Font
	STI
end;

procedure SetStandart; near; assembler;
asm
	CALL	Open_A000_Font
	MOV		ES, SegA000
	MOV		BX, OFFSET ReplaceCharMap
	MOV		SI, OFFSET MasterCharMap
	CLD
	MOV		CX, MasterCharsInUse
@1:	LODSB
	MOV		AH, 0
	MOV		DI, AX
	XCHG	BX, SI
@2:	LODSW
	TEST	AH, AH
	JNE		@2
	XCHG	BX, SI
	PUSH	CX
	PUSH	SI
	MOV		AH, 0
	MOV		SI, AX
	MOV		CL, 5
	SHL		SI, CL
	SHL		DI, CL
	MOV		CL, BYTE PTR DevicesInfo.Vscan
	SEGES	REP MOVSB
	RCR		CX, 1
	SEGES	REP	MOVSW
	POP		SI
	POP		CX
	LOOP	@1
end;

procedure SetMasterXlat; near; assembler;
asm
	PUSH	DS
	POP		ES
	MOV		SI, OFFSET MasterCharMap
	MOV		BX, OFFSET ReplaceCharMap
	MOV		CX, MasterCharsInUse
	XOR		AX, AX
	CLD
@1:	LODSB
	PUSH	CX
	MOV		CX, 256
	MOV		DI, OFFSET XlatScreen
	REPNE	SCASB
	POP		CX
	SUB		DI, OFFSET XlatScreen + 1
	XCHG	SI, BX
@2:	LODSW
	TEST	AH, AH
	JNE		@2
	XCHG	SI, BX
	MOV		AH, 0
	CMP		DI, AX
	JE		@3
	MOV		BYTE PTR XlatScreen [DI], AL
{$IFDEF SupportMasterMouse}
	CMP		SI, OFFSET MasterCharMap + TYPE MasterCharMap - 9
	JA		@3
{$ENDIF}
	MOV		DI, AX
	MOV		AL, [SI - 1]
	MOV		BYTE PTR XlatScreen [DI], AL
@3:	LOOP	@1
end;

procedure UndoMasterXlat; near; assembler;
asm
	MOV		SI, OFFSET MasterCharMap
	MOV		DI, OFFSET ReplaceCharMap
	MOV		CX, MasterCharsInUse
	XOR		AX, AX
	CLD
@1:	LODSB
	MOV		BX, AX
	XCHG	SI, DI
@2:	LODSW
	TEST	AH, AH
	JNE		@2
	XCHG	SI, DI
	CMP		BYTE PTR XlatScreen [BX], AL
	JNE		@3
	MOV		BYTE PTR XlatScreen [BX], BL
	MOV		BX, AX
	MOV		BYTE PTR XlatScreen [BX], AL
@3:	LOOP	@1
	MOV		SI, OFFSET ReplaceCharMap
	MOV		DI, OFFSET StandartImage
	MOV		CX, TYPE StandartImage
@4:	LODSW
	MOV		AH, 0
	MOV		BX, AX
	XCHG	SI, DI
	LODSB
	XCHG	SI, DI
	MOV		BYTE PTR XlatScreen [BX], AL
	LOOP	@4
end;

procedure SetMaster (The : Boolean);
begin
	Config.MasterFont := The;
	ResetMaster;
end;

const
	OldScan : Word = 0;

procedure ResetMaster;
const
	DoSet	: Boolean = True;
begin
	HideMouse;
	if Config.MasterFont and (DevicesInfo.Vscan > 7) then
		begin
			if OldScan <> DevicesInfo.Vscan then
				begin
					DoSet := True;
					OldScan := DevicesInfo.Vscan;
					SaveFont;
				end;
			if DoSet then
				begin
					DoSet := False;
					SetMasterXlat;
					SetMasterFont;
				end;
		end
	else
		begin
			if not DoSet then
				begin
					if DevicesInfo.Vscan = OldScan then
						begin
							SetStandart;
							RestoreFont;
						end;
					DoSet := True;
				end;
			UndoMasterXlat;
        end;
{$IFDEF SupportMasterMouse}
	AdjustMouse (Config.MouseGraph);
{$ENDIF}
	ShowMouse;
end;

procedure SetMasterCodeStyle (The : TCharCodeStyles);
const
	MasterCharStyles	: array [TCharCodeStyles] of TMasterCharMap =
		(MasterCharsALT, MasterCharsMAIN, MasterCharsMIC, MasterCharsKOI8, MasterCharsKOI8M, MasterCharsIBMPC);
begin
	HideMouse;
	OldScan := 0;
	MasterCharMap := MasterCharStyles [The];
{$IFDEF SupportMasterMouse}
	asm
		PUSH	DS
		POP		ES
		MOV		SI, OFFSET MasterCharMap + TYPE MasterCharMap - 9
		MOV		DI, OFFSET ReplaceCharMap + TYPE ReplaceCharMap - 9 * 2
		MOV		BX, OFFSET MouseImage
		CLD
		MOV		CX, 9
	@1:	MOVSB
		MOV		AL, [BX]
		MOV		[SI - 1], AL
		INC		BX
		INC		DI
		LOOP	@1
	end;
{$ENDIF}
	ShowMouse;
end;

{$ENDIF}
procedure SetBlink (As : Boolean); assembler;
asm
	MOV		AL, As
	MOV		Config.Blink, AL
	MOV		ES, Seg0040
	MOV		AL, ES:[0087H]
	TEST	AL, AL
	JE		@2
	TEST	AL, 4
	JNE		@2
	MOV		AX, 1003H
	XOR		BX, BX
	TEST	As, -1
	JE		@1
	INC		BL
@1:	CALL	VideoInt
	JMP		@4
@2: MOV		AL, ES:[0065H]
	AND		AL, 11011111B
	TEST	As, -1
	JE		@3
	OR		AL, 00100000B
@3: MOV		DX, ES:[0063H]
	ADD		DL, 4
	MOV		ES:[0065H], AL
	OUT		DX, AL
@4:
end;

procedure SetBorderColor (Color : Byte); assembler;
asm
	MOV		BH, Color
	MOV		ES, Seg0040
	MOV		AL, ES:[0087H]
	TEST	AL, AL
	JE		@1
	TEST	AL, 4
	JNE		@1
	MOV		AX, 1001H
	CALL	VideoInt
	JMP		@3
@1:	MOV		BL, BH
	MOV		CL, 3
	SAR		BL, CL
	AND		BL, BH
	AND		BL, 7
	JE		@2
	OR		BH, 8
@2:	MOV		AL, ES:[0066H]
	AND		AL, 11110000B
	OR		AL, BH
	MOV		DX, ES:[0063H]
	ADD		DL, 5
	MOV		ES:[0066H], AL
	OUT		DX, AL
@3:
end;

procedure DetectVideo; assembler;
asm
	CALL	GetCrtMode
	CALL	FixCrtMode
	MOV		DevicesInfo.ScreenMode, AX
end;

procedure InitVideo; assembler;
asm
	CALL	GetCrtMode
	MOV		DevicesInfo.StartupMode, AX
	CMP		AX, DevicesInfo.ScreenMode
	JE		@1
	MOV		AX, DevicesInfo.ScreenMode
	CALL	SetCrtMode
@1:	CALL	SetCrtData
end;

procedure DoneVideo; assembler;
asm
	MOV		AX, DevicesInfo.StartupMode
	CMP		AX, 0FFFFH
	JE		@2
	CMP		AX, DevicesInfo.ScreenMode
	JE		@1
	CALL	SetCrtMode
	JMP		@2
@1:	CALL	ClearScreen
	MOV		AH, 1
	MOV		CX, DevicesInfo.CursorLines
	CALL	VideoInt
@2:
end;

procedure SetVideoMode (Mode : Word); assembler;
asm
	MOV		AX, Mode
	CALL	FixCrtMode
	CALL	SetCrtMode
	CALL	SetCrtData
end;

procedure ClearScreen; assembler;
asm
	MOV		AX, 600H
	MOV		BH, 07H
	XOR		CX, CX
	MOV		DL, DevicesInfo.ScreenWidth
	DEC		DL
	MOV		DH, DevicesInfo.ScreenHeight
	DEC		DH
	CALL	VideoInt
	MOV		AH, 2
	MOV		BH, 0
	XOR		DX, DX
	CALL	VideoInt
end;

procedure DetectMouse; near; assembler;
asm
	MOV		AX, 3533H
	INT		21H
	MOV		AX, ES
	OR		AX, AX
	JE		@2
	MOV		AX, 33
	INT		33H
	INC		AX
	JE		@1
	XOR		AX, AX
	INT		33H
	INC		AX
	JNE		@2
@1:	MOV		DevicesInfo.ButtonCount, BL
@2:
end;

procedure StoreEvent; near; assembler;
asm
	MOV		DI, SP
	LES		DI, SS:[DI+8]
	CLD
	STOSW
	XCHG	AX, BX
	STOSW
	XCHG	AX, CX
	STOSW
	XCHG	AX, DX
	STOSW
end;

procedure InitEvents; assembler;
asm
	XOR		AX, AX
	MOV		ES, AX
	MOV		BX, ES:TimerLow
	MOV		WORD PTR MouseMark, BX
	MOV		BX, ES:TimerLow + 2
	MOV		WORD PTR MouseMark + 2, BX
	MOV		BX, OFFSET EventQueue
	MOV		EventQHead, BX
	MOV		EventQTail, BX
	CMP		AL, DevicesInfo.ButtonCount
	JE		@1
	MOV		AX, 3
	INT		33H
	XCHG	AX, CX
	MOV		CL, 3
	SHR		AX, CL
	SHR		DX, CL
	MOV		MouseButtons, BL
	MOV		MouseWhere.X, AX
	MOV		MouseWhere.Y, DX
	MOV		LastButtons, BL
	MOV		LastWhere.X, AX
	MOV		LastWhere.Y, DX
	MOV		MouseEvents, 1
@1:
{$IFDEF SupportMasterMouse}
	XOR		AX, AX
	PUSH	AX
{$ENDIF}
	CALL	AdjustMouse
	CALL	ShowMouse
	MOV		AH, 2
	INT		16H
	NOT		AL
	MOV		BL, AL
	MOV		AH, 12
	INT		16H
	CMP		AL, BL
	MOV		BH, 0
	JNE		@2
	XOR		BX, BX
@2:	MOV		DevicesInfo.KeyBoardType, BH
end;

procedure DoneEvents; assembler;
asm
	CMP		DevicesInfo.ButtonCount, 0
	JE		@1
	CMP		MouseEvents, 0
	JE		@1
	MOV		MouseEvents, 0
	MOV		AX, 2
	INT		33H
	MOV		AX, 12
	XOR		CX, CX
	MOV		DX, CX
	MOV		ES, CX
	INT		33H
@1:
end;

procedure NormalMouse;
begin
	MarkMouse (msNormal);
end;

procedure MarkMouse (The : TMouseState);
var
	P	: PMouseAnimator;
begin
{$IFDEF SupportMasterMouse}
	if Config.MouseGraph then
		MouseAnimator := GraphMouseAnimators [The]
	else
{$ENDIF}
		MouseAnimator := TextMouseAnimators [The];
	if The <> MouseState then
		begin
			MouseState := The;
			RedrawMouse;
		end;
end;

procedure GetMouseState; assembler;
asm
	CLI
	CMP		EventCount, 0
	JNE		@1
	MOV		BL, MouseButtons
	MOV		CX, MouseWhere.Word [0]
	MOV		DX, MouseWhere.Word [2]
	MOV		ES, Seg0040
	MOV		DI, ES:TimerLow
	JMP		@3
@1:	MOV		SI, EventQHead
	CLD
	LODSW
	XCHG	AX, DI
	LODSW
	XCHG	AX, BX
	LODSW
	XCHG	AX, CX
	LODSW
	XCHG	AX, DX
	CMP		SI, OFFSET EventQLast
	JNE		@2
	MOV		SI, OFFSET EventQueue
@2:	MOV		EventQHead, SI
	DEC		EventCount
@3:	STI
	CMP		MouseReverse, 0
	JE		@4
	MOV		BH, BL
	AND		BH, 3
	JE		@4
	CMP		BH, 3
	JE		@4
	XOR		BL, 3
@4:
end;

procedure GetMouseEvent (var Event : TEvent); assembler;
asm
	CMP		MouseEvents, 0
	JE		@2
	CALL	GetMouseState
	MOV		BH, LastDouble
	MOV		AL, LastButtons
	CMP		AL, BL
	JE		@1
	OR		AL, AL
	JE		@3
	OR		BL, BL
	JE		@5
	MOV		BL, AL
@1:	CMP		CX, LastWhere.X
	JNE		@6
	CMP		DX, LastWhere.Y
	JNE		@6
	OR		BL, BL
	JE		@2
	MOV		AX, DI
	SUB		AX, AutoTimer
	CMP		AX, AutoDelay
	JAE		@7
@2:	XOR		AX, AX
	MOV		BX, AX
	MOV		CX, AX
	MOV		DX, AX
	JMP		@9
@3:	MOV		BH,0
	CMP		BL, DownButtons
	JNE		@4
	CMP		CX, DownWhere.X
	JNE		@4
	CMP		DX, DownWhere.Y
	JNE		@4
	MOV		AX, DI
	SUB		AX, DownTimer
	CMP		AX, DoubleDelay
	JAE		@4
	MOV		BH, 1
@4:	MOV		DownButtons, BL
	MOV		DownWhere.X, CX
	MOV		DownWhere.Y, DX
	MOV		DownTimer, DI
	MOV		AutoTimer, DI
	MOV		AX, RepeatDelay
	MOV		AutoDelay, AX
	MOV		AX, evMouseDown
	JMP		@8
@5:	MOV		AX, evMouseUp
	JMP		@8
@6:	MOV		AX, evMouseMove
	JMP		@8
@7:	MOV		AutoTimer, DI
	MOV		AutoDelay, 1
	MOV		AX, evMouseAuto
@8:	MOV		LastButtons, BL
	MOV		LastDouble, BH
	MOV		LastWhere.X, CX
	MOV		LastWhere.Y, DX
@9:	CALL	StoreEvent
end;

procedure GetKeyEvent (var Event : TEvent); assembler;
asm
	TEST	WORD PTR PrnHandle [2], -1
	JE		@0
	CALL	PrnHandle
@0: MOV		CL, DevicesInfo.KeyBoardType
	MOV		AH, 1
	ADD		AH, CL
	INT		16H
	MOV		AX, 0
	MOV		BX, AX
	JE		@1
	MOV		AH, CL
	INT		16H
	TEST	CL, CL
	JE		@2
	CMP		AL, 0E0H
	JNE		@2
	CMP		AH, 47H
	JB		@2
	MOV		AL, 0
@2:	CMP		AL, 127
	JBE		@3
	MOV		BX, OFFSET XlatKeyBoard - 128
	XLAT
@3:	XCHG	AX, BX
	MOV		AX, evKeyDown
@1:	XOR		CX, CX
	MOV		DX, CX
	CALL	StoreEvent
end;

function HotKey (S : String) : Char; assembler;
asm
	LES		DI, S
	MOV		CL, ES:[DI]
	INC		DI
	MOV		CH, 0
	JCXZ	@1
	CLD
	MOV		AL, '&'
	REPNE	SCASB
	JNE		@1
	MOV		CH, ES:[DI]
@1:	MOV		AL, CH
	PUSH	AX
	CALL	KeyCase
end;

function KeyCase (C : Char) : Char; assembler;
asm
	PUSH	WORD PTR C
	CALL	UpCase
	CMP		AL, 128
	JB		@3
	CMP		AL, 160
	JB		@2
	CMP		AL, 200
	JE		@1
	CMP		AL, 201
	JNE		@3
@1:	MOV		AL, 17
	JMP		@3
@2:	MOV		BX, OFFSET KeyBoardMap
	AND		AL, $7F
	XLAT
@3:
end;
											 {1                   2                   3         3}
const                                        {0123456789AB  C  DEF01234567  8  9ABCDEF0123456789A}
	AltCodes1	: array [$10..$3A] of Char = 'QWERTYUIOP[]'#17'ASDFGHJKL;'#39'`~\ZXCVBNM,./{ }';
	AltCodes2	: array [$78..$83] of Char = '1234567890-=';

function GetAltChar (KeyCode : Word) : Char;
begin
	GetAltChar := #0;
	if Lo (KeyCode) = 0 then
		case Hi (KeyCode) of
				$02		: GetAltChar := #240;
				$10..$3A	: GetAltChar := AltCodes1 [Hi (KeyCode)];
				$78..$83	: GetAltChar := AltCodes2 [Hi (KeyCode)];
		end;
end;

function GetAltCode (Ch : Char) : Word;
var
	I : Word;
begin
	GetAltCode := 0;
	if Ch = #0 then Exit;
	Ch := KeyCase (Ch);
	if Ch = #240 then
		begin
			GetAltCode := $0200;
			Exit;
		end;
	for I := $10 to $35 do
		if AltCodes1 [I] = Ch then
			begin
				GetAltCode := I shl 8;
				Exit;
			end;
	for I := $78 to $83 do
		if AltCodes2 [I] = Ch then
			begin
				GetAltCode := I shl 8;
				Exit;
			end;
end;

function CtrlToArrow (KeyCode : Word) : Word;
const
	NumCodes = 10;
	CtrlCodes	: array [0..NumCodes - 1] of Char = ^S^D^E^X^A^F^G^V^R^C;
	ArrowCodes	: array [0..NumCodes - 1] of Word =
		(kbLeft, kbRight, kbUp, kbDown, kbHome, kbEnd, kbDel, kbIns, kbPgUp, kbPgDn);
var
	I : Integer;
begin
	CtrlToArrow := KeyCode;
	for I := 0 to NumCodes - 1 do
		if WordRec (KeyCode).Lo = Byte (CtrlCodes [I]) then
			begin
				CtrlToArrow := ArrowCodes [I];
				Exit;
			end;
end;

{$L FORMAT}

procedure FormatStr (var Result : String; Format : String; var Params); external;

procedure PrintStr (S : String); assembler;
asm
	PUSH	DS
	LDS		SI, S
	CLD
	LODSB
	MOV		CL, AL
	MOV		CH, 0
	MOV		AH, 40H
	MOV		BX, 1
	MOV		DX, SI
	INT		21H
	POP		DS
end;

procedure MoveBuf (var Dest; var Source; Attr : Word; Count : Word); assembler;
asm
	MOV		CX, Count
	JCXZ	@5
	MOV		DX, DS
	LES		DI, Dest
	LDS		SI, Source
	MOV		AH, BYTE PTR Attr
	CLD
	OR		AH, AH
	JE		@3
@1:	LODSB
	STOSW
	LOOP	@1
	JMP		@4
@2:	INC		DI
@3:	STOSB
	LOOP	@2
@4:	MOV		DS, DX
@5:
end;

procedure MoveCBuf (var Dest; var Source; Attr : Word; Count : Word); assembler;
asm
	MOV		CX, Count
	JCXZ	@5
	MOV		DX, DS
	LES		DI, Dest
	LDS		SI, Source
	MOV		BX, Attr
	CLD
	MOV		AH, BL
	OR		AH, AH
	JE		@3
@1:	LODSB
	CMP		AL, '~'
	JE		@0
	STOSW
	LOOP	@1
	JMP		@4
@0:	XCHG	BH, AH
	JMP		@1
@2:	INC		DI
@3:	STOSB
	LOOP	@2
@4:	MOV		DS, DX
@5:
end;

procedure MoveChar (var Dest; C : Char; Attr : Word; Count : Word); assembler;
asm
	MOV		CX, Count
	JCXZ	@4
	LES		DI, Dest
	MOV		AL, C
	MOV		AH, BYTE PTR Attr
	CLD
	OR		AL, AL
	JE		@1
	OR		AH, AH
	JE		@3
	REP		STOSW
	JMP		@4
@1:	MOV		AL, AH
@2:	INC		DI
@3:	STOSB
	LOOP	@2
@4:
end;

procedure MoveCStr (var Dest; Str : String; Attrs : Word); assembler;
asm
	MOV		DX, DS
	LDS		SI, Str
	CLD
	LODSB
	MOV		CL, AL
	MOV		CH, 0
	JCXZ	@4
	LES		DI, Dest
	MOV		BX, Attrs
	MOV		AH, BL
@1:	LODSB
	CMP		AL, '~'
	JE		@2
	CMP		AL, '&'
	JE		@3
	STOSW
	LOOP	@1
	JMP		@4
@2:	XCHG	AH, BH
	LOOP	@1
	JMP		@4
@3:	DEC		CX
	JE		@4
	XCHG	AH, BH
	LODSB
	STOSW
	XCHG	AH, BH
	LOOP	@1
@4:	MOV		DS, DX
end;

procedure MoveMarkCStr (var Dest; Str : String; Attr : Word; Size : Word; SCOff : TSpecialCharsUser); assembler;
asm
	LES		DI, Dest
	MOV		BX, DI
	CLD
	MOV		CX, Size
	MOV		AH, BYTE PTR Attr
	MOV		AL, ' '
	REP		STOSW
	PUSH	DI
	PUSH	BX
	MOV		CX, WORD PTR Str [2]
	JCXZ	@1
	PUSH	ES
	ADD		BX, 2
	PUSH	BX
	PUSH	CX
	PUSH	WORD PTR Str
	PUSH	Attr
	CALL	MoveCStr
@1:	MOV		SI, WORD PTR SCOff
	AND		SI, 0FFH
	ADD		SI, SI
	ADD		SI, OFFSET SpecialChars
	POP		DI
	MOVSB
	POP		DI
	SUB		DI, 2
	MOVSB
end;

procedure MoveStr (var Dest; Str : String; Attr : Word); assembler;
asm
	MOV		DX, DS
	LDS		SI, Str
	CLD
	LODSB
	MOV		CL, AL
	XOR		CH, CH
	JCXZ	@4
	LES		DI, Dest
	MOV		AH, BYTE PTR Attr
	OR		AH, AH
	JE		@3
@1:	LODSB
	STOSW
	LOOP	@1
	JMP		@4
@2:	INC		DI
@3:	MOVSB
	LOOP	@2
@4:	MOV		DS, DX
end;

function CStrLen (var S : String) : Integer; assembler;
asm
	LES		DI, S
	MOV		CL, ES:[DI]
	INC		DI
	MOV		CH, 0
	MOV		BX, CX
	MOV		DX, CX
	JCXZ	@2
	MOV		AL,'~'
	CLD
	MOV		SI, DI
@1:	REPNE	SCASB
	JNE		@2
	DEC		BX
	JMP		@1
@2:	MOV		DI, SI
	MOV		AL, '&'
	MOV		CX, DX
@3:	REPNE	SCASB
	JNE		@4
	DEC		BX
	JMP		@3
@4:	MOV		AX, BX
end;

procedure DoneDrivers;
begin
	HideMouse;
	asm
		XOR		AX, AX
		MOV		ES, AX
		MOV		SI, OFFSET PrnDelay
		MOV		DI, 0478H
		CLD
		MOVSW
		MOVSW
	end;
{$IFDEF SupportMasterFont}
	SetMaster (False);
{$ENDIF}
	SetCurFont (0, 0);
	SetBlink (True);
end;

procedure InitDrivers;
begin
	asm
		PUSH	DS
		POP		ES
{$IFDEF SupportMasterMouse}
		MOV		DI, OFFSET GraphMouseAnimators
		MOV		CX, (TYPE (GraphMouseAnimators) + TYPE (TextMouseAnimators)) / 2
{$ELSE}
		MOV		DI, OFFSET TextMouseAnimators
		MOV		CX, TYPE (TextMouseAnimators) / 2
{$ENDIF}
		CLD
		XOR		AX, AX
		REP		STOSW
	end;
	asm
		MOV		ES, Seg0040
		MOV		CX, 4
		MOV		DI, OFFSET PrnDelay
		MOV		SI, 078H
	@1:	MOV		AL, 1
		XCHG	AL, ES:[SI]
		INC		SI
		MOV		[DI], AL
		INC		DI
		LOOP	@1
	end;
	DetectMouse;
	DetectVideo;
end;

end.

