{$D+}

unit	Workadd;

interface

uses	Objects, Views, WorkMain, Person, TheAll, TabView, DNew,
		OtdView, CharLog;

type

	PWorkSVadd = ^TWorkSVadd;
	TWorkSVadd = Object (TWorkAll)
		constructor	Init (AMain : PWorkMain);
		function	Format : PTitle; virtual;
		function	Data (I : Integer) : Pointer; virtual;
		function	InitList (Var R : TRect; ALink : PListViewer; AHeight : Integer; HS, VS : PScrollBar) : PItemList; virtual;
		function	ItemsCount : Integer; virtual;
		function	Ptr : Pointer; virtual;
	end;

	PAddList = ^TAddList;
	TAddList = Object (TMonthList)
		function GetText (N, M : Integer) : String; virtual;
	end;

implementation

constructor TWorkSVadd.Init (AMain : PWorkMain);
	var
		R	: TRect;
	begin
		R.Assign (0, 0, 70, 21);
		TWorkAll.Init (R, ' ᫥', AMain);
	end;

function TWorkSVadd.Ptr : Pointer;
	begin
		Ptr := @Main^.SVadd;
	end;

function TWorkSVadd.InitList (Var R : TRect; ALink : PListViewer; AHeight : Integer; HS, VS : PScrollBar) : PItemList;
	begin
		InitList := New (PAddList, Init (R, ' ᫥  栬', AHeight, ALink, HS, VS));
	end;

function TWorkSVadd.ItemsCount : Integer;
	begin
		ItemsCount := TWorkAll.ItemsCount * 12;
	end;

function TWorkSVadd.Format : PTitle;
	begin
		Format := NewHead (
			NewTitle(' ⥣', 1,
				NewReal	('', 1,
				NewReal	('㦠騥', 1,
				NewReal	('稥', 1,
				NewReal ('', 1,
				NewReal ('.୯', 1,
				NewReal ('.', 1,
				NewReal ('࠭', 1, nil))))))),
			NewReal ('⮣', 1, nil)));
	end;

function TWorkSVadd.Data (I : Integer) : Pointer;
	begin
		Data := Pointer (Longint (@Main^.Otdel^.All.Data [I div 12].Add)
						 + SizeOf (TWorksByKat) * (I mod 12));
	end;

function TAddList.GetText (N, M : Integer) : String;
	const
		cNames : array [0..10] of String [20] =
		(
			'६',
			'. .',
			'+  ᭮',
			'+  ନ /',
			'᮪',
			'. ',
			'। ',
			'. ࠡ⮪',
			'⮣  ',
			'ᮡ. ',
			'/⢨'
		);
	var
		S	: String;
		C	: Char;
	begin
		if N mod 12 = 11 then
			begin
				M := Size.X;
				S := TMonthList.GetText (N div 12, M);
				GetText := S + RepeatChar (M - Length (S) - 7, '.') + '⮣';
			end
		else
			begin
				if N mod 12 = 0 then C := '' else if N = Range - 1 then C := '' else C := '';
				GetText := ' '+ C + cNames [N mod 12];
			end;
	end;
end.