{$D-}

unit	WorkInfo;

interface

uses	Objects, Drivers, Views, Dialogs, App, MsgBox,
		ZarInc,
		OtdView, Otdel, Person, TabView, DNew,
		WorkMain;

type

	PWorkInfo = ^TWorkInfo;
	TWorkInfo = Object (TWorkOther)
		constructor Init (AMain : PWorkMain);
		function	Format : PTitle; virtual;
		function	Data (I : Integer) : Pointer; virtual;
		function	Ptr : Pointer; virtual;
	end;

implementation

constructor TWorkInfo.Init (AMain : PWorkMain);
	var
		R	: TRect;
	begin
		R.Assign (0, 0, 70, 21);
		TWorkOther.Init (R, 'ଠ 㤭', AMain);
		with List^ do Options := Options or ofEditable;
	end;

function TWorkInfo.Ptr : Pointer;
	begin
		Ptr := @Main^.Info;
	end;

function ByDay (Next : PColumn) : PColumn;
	begin
		ByDay :=
				NewReal	('砫', 1,
				NewReal	('', 1,
				NewByte	('', 3, 1, Next)));
	end;

function TWorkInfo.Format : PTitle;
	begin
		Format := NewHead (
			NewLongint('  ', 1,
			NewByte('', 3, 1,
			NewTitle('', 1,
				NewSet	('', 1,
					NewState('',
					NewState('६', nil)),
				ByDay	(nil)),
			NewSet	('६', 1,
				NewState('',
				NewState('',
				NewState('ॢ',
				NewState('', nil)))),
			NewTitle('ᯮ⥫ ', 1,
				NewReal	('', 1,
				NewReal	('ன', 1,
				NewReal	('⨩', 1,
				NewReal	('᫥', 1, nil)))),
			NewTitle('', 1,
				NewReal(' ᭮', 1,
				NewReal(' / ࠡ ', 1,
				NewReal(' ࠡ  ', 1,
				NewReal(' 殮 /', 1,
				NewReal(' ਣ⢮', 1,
				NewYesNo('', 1,
				NewYesNo('', 1,
				NewReal('ᮭ쭠', 1, nil)))))))), nil)))))));
	end;

function TWorkInfo.Data (I : Integer) : Pointer;
	begin
		Data := @PPerson (Main^.Otdel^.At (I))^.Info.Number;
	end;

end.