{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit DNew;

interface

uses	Objects, TabView, DView;

{$I VERSION}

	function NewHead (Sub : PColumn) : PTitle;
	function NewTitle (Title : String; AHeight : Integer; ASub, ANext : PColumn) : PColumn;
	function NewColumn (Title : String; ASize, AWidth, AHeight : Integer; ANext : PColumn) : PColumn;


	function NewState (Title : String; ANext : PMobileRec) : PMobileRec;
	function NewSet (Title : String; AHeight : Integer; ABase : PMobileRec; ANext : PColumn) : PColumn;
	function NewFloat (Title : String; AWidth, ADec, AHeight : Integer; ANext : PColumn) : PColumn;
	function NewReal (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	function NewYesNo (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	function NewByte (Title : String; AWidth, AHeight : Integer; ANext : PColumn) : PColumn;
	function NewInteger (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	function NewString (Title : String; AWidth, AHeight : Integer; ANext : PColumn) : PColumn;
	function NewLongint (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;

implementation

function NewHead (Sub : PColumn) : PTitle;
	begin
		NewHead := New (PTitle, Init (Sub));
	end;

function NewColumn (Title : String; ASize, AWidth, AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewColumn := New (PColumn, Init (NewStr (Title), ASize, AWidth, AHeight, nil, ANext));
	end;

function NewTitle (Title : String; AHeight : Integer; ASub, ANext : PColumn) : PColumn;
	begin
		NewTitle := New (PColumn, Init (NewStr (Title), 0, 0, AHeight, ASub, ANext));
	end;

function NewState (Title : String; ANext : PMobileRec) : PMobileRec;
	begin
		NewState := New (PMobileRec, Init (NewStr (Title), ANext));
	end;

function NewSet (Title : String; AHeight : Integer; ABase : PMobileRec; ANext : PColumn) : PColumn;
	begin
		NewSet := New (PCMobile, Init (NewStr (Title), ABase, AHeight, ANext));
	end;

function NewFloat (Title : String; AWidth, ADec, AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewFloat := New (PCFloat, Init (NewStr (Title), AWidth, ADec, AHeight, ANext));
	end;

function NewReal (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewReal := New (PCFloat, Init (NewStr (Title), 8, 2, AHeight, ANext));
	end;

function NewYesNo (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewYesNo := New (PCYesNo, Init (NewStr (Title), AHeight, ANext));
	end;

function NewByte (Title : String; AWidth, AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewByte := New (PCByte, Init (NewStr (Title), AWidth, AHeight, ANext));
	end;

function NewInteger (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewInteger := New (PCInteger, Init (NewStr (Title), AHeight, ANext));
	end;

function NewString (Title : String; AWidth, AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewString := New (PCString, Init (NewStr (Title), AWidth, AHeight, ANext));
	end;

function NewLongint (Title : String; AHeight : Integer; ANext : PColumn) : PColumn;
	begin
		NewLongint := New (PCLongint, Init (NewStr (Title), AHeight, ANext));
	end;

end.