{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}
{$G-,O-}

unit XCPU;

interface

{$I VERSION}

function CPU : Byte;
procedure TestCPU (AName : String; At : Byte);

implementation

procedure TestCPU (AName : String; At : Byte); assembler;
asm
	PUSH	DS
	LDS		SI, AName
	MOV		DX, SI
	INC		DX
	MOV		CL, [SI]
	MOV		CH, 0
	MOV		AH, 40H
	MOV		BX, 2
	INT		21H
	POP		DS
	CALL	CPU
	CMP		AL, At
	JAE		@E
	MOV		AL, At
	ADD		BYTE PTR CS:[OFFSET @N], AL
	MOV		AH, 40H
	MOV		CX, 36
	MOV		BX, 2
	MOV		DX, OFFSET @M
	PUSH	DS
	PUSH	CS
	POP		DS
	INT		21H
	POP		DS
	MOV		AX, 4C05H
	INT		21H
@M:	DB		'This program required INTEL '
@N:	DB		'086...', 0DH, 0AH
@E:
end;

function CPU; assembler;
asm
	MOV		AL, 0
	MOV		DX, -1
	MOV		CL, 42H
	SHR		DX, CL
	TEST	DX, 3FFFH
	JE		@E
	INC		AX
	PUSH	SP
	POP		BX
	CMP		BX, SP
	JNE		@E
	INC		AX
	MOV		BX, 7000H
	PUSHF
	PUSH	BX
	POPF
	PUSHF
	POP		BX
	POPF
	AND 	BH, 70H
	JE		@E
	INC		AX
@E:
end;

end.